//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Generator.Test.TestReference
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Listen for log entries command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ListenForLogEntriesRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ListenForLogEntriesRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ListenForLogEntriesRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "tecan.sila.generator.test.logging/infrastructure/LoggingService/v4/Command/Listen" +
                    "ForLogEntries";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the intermediate response of the Listen for log entries command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ListenForLogEntriesIntermediateDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private LogEntryDto _intermediate;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ListenForLogEntriesIntermediateDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ListenForLogEntriesIntermediateDto(LogEntry intermediate, Tecan.Sila2.IBinaryStore store)
        {
            Intermediate = new LogEntryDto(intermediate, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public LogEntryDto Intermediate
        {
            get
            {
                return _intermediate;
            }
            set
            {
                _intermediate = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Intermediate, "intermediate");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Intermediate, "intermediate"));
        }
    }
    
    /// <summary>
    /// The data transfer object for Log Entry Data
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class LogEntryDataDto : Tecan.Sila2.ISilaTransferObject<LogEntryData>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public LogEntryDataDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public LogEntryDataDto(LogEntryData inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        public Tecan.Sila2.StringDto Key
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Key;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Key = value;
            }
        }
        
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Value;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Value = value;
            }
        }
        
        public System.Collections.Generic.List<LogEntryDataDto> Children
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Children;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Children = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public LogEntryData Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new LogEntryData(Key.Extract(store), Value.Extract(store), Children.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static LogEntryDataDto Create(LogEntryData inner, Tecan.Sila2.IBinaryStore store)
        {
            return new LogEntryDataDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(Key, "key")) 
                        + Argument.Require(Value, "value")) 
                        + Argument.Require(Children, "children"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _key;
            
            private Tecan.Sila2.StringDto _value;
            
            private System.Collections.Generic.List<LogEntryDataDto> _children;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(LogEntryData inner, Tecan.Sila2.IBinaryStore store)
            {
                Key = new Tecan.Sila2.StringDto(inner.Key, store);
                Value = new Tecan.Sila2.StringDto(inner.Value, store);
                Children = Tecan.Sila2.DtoExtensions.Encapsulate(inner.Children, LogEntryDataDto.Create, store);
            }
            
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto Key
            {
                get
                {
                    return _key;
                }
                set
                {
                    _key = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.StringDto Value
            {
                get
                {
                    return _value;
                }
                set
                {
                    _value = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(3)]
            public System.Collections.Generic.List<LogEntryDataDto> Children
            {
                get
                {
                    return _children;
                }
                set
                {
                    _children = value;
                }
            }
        }
    }
    
    /// <summary>
    /// The data transfer object for the Severity enumeration
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SeverityDto : Tecan.Sila2.ISilaTransferObject<Severity>
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public SeverityDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public SeverityDto(Severity inner, Tecan.Sila2.IBinaryStore store)
        {
            Value = inner.ToString();
        }
        
        /// <summary>
        /// The string representation of the given enum member
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public Severity Extract(Tecan.Sila2.IBinaryStore store)
        {
            return ((Severity)(System.Enum.Parse(typeof(Severity), Value.Value)));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static SeverityDto Create(Severity inner, Tecan.Sila2.IBinaryStore store)
        {
            return new SeverityDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// The data transfer object for Log Entry
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class LogEntryDto : Tecan.Sila2.ISilaTransferObject<LogEntry>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public LogEntryDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public LogEntryDto(LogEntry inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        public Tecan.Sila2.StringDto Message
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Message;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Message = value;
            }
        }
        
        public Tecan.Sila2.StringDto Channel
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Channel;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Channel = value;
            }
        }
        
        public SeverityDto Severity
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Severity;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Severity = value;
            }
        }
        
        public System.Collections.Generic.List<LogEntryDataDto> Data
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Data;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Data = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public LogEntry Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new LogEntry(Message.Extract(store), Channel.Extract(store), Severity.Extract(store), Data.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static LogEntryDto Create(LogEntry inner, Tecan.Sila2.IBinaryStore store)
        {
            return new LogEntryDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (((("" + Argument.Require(Message, "message")) 
                        + Argument.Require(Channel, "channel")) 
                        + Argument.Require(Severity, "severity")) 
                        + Argument.Require(Data, "data"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _message;
            
            private Tecan.Sila2.StringDto _channel;
            
            private SeverityDto _severity;
            
            private System.Collections.Generic.List<LogEntryDataDto> _data;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(LogEntry inner, Tecan.Sila2.IBinaryStore store)
            {
                Message = new Tecan.Sila2.StringDto(inner.Message, store);
                Channel = new Tecan.Sila2.StringDto(inner.Channel, store);
                Severity = new SeverityDto(inner.Severity, store);
                Data = Tecan.Sila2.DtoExtensions.Encapsulate(inner.Data, LogEntryDataDto.Create, store);
            }
            
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto Message
            {
                get
                {
                    return _message;
                }
                set
                {
                    _message = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.StringDto Channel
            {
                get
                {
                    return _channel;
                }
                set
                {
                    _channel = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(3)]
            public SeverityDto Severity
            {
                get
                {
                    return _severity;
                }
                set
                {
                    _severity = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(4)]
            public System.Collections.Generic.List<LogEntryDataDto> Data
            {
                get
                {
                    return _data;
                }
                set
                {
                    _data = value;
                }
            }
        }
    }
}
